﻿using System;

namespace ValidateIndex
{
    public class RowModelBase : Observable
    {
        #region model
        private DateTime? _dateImport;
        private DateTime? _dateSent;
        private DateTime? _dateConfirm;
        private DateTime? _datLastAnswer;

        private bool _read;
        private string _owner;
        private string _docCircId;
        private DocCirculationStates _stateId;
        private int _docCircType;
        private string _orgName;
        private string _organizationShortName;
        private string _period;
        private string _formDescription;
        private string _reсeiverCode;
        private string _year;
        private int? _taxpayerId;
        private int? _idUser;
        private string _progress;
        private int _layout;
        #endregion

        [Binding(Name = "read")]
        public bool Read
        {
            get { return _read; }
            set
            {
                _read = value;
                RaisePropertyChanged(() => Read);
            }
        }

        [Binding(Name = "formName")]
        public virtual string FormDescription
        {
            get { return _formDescription; }
            set
            {
                _formDescription = value;
                RaisePropertyChanged(() => FormDescription);
            }
        }

        [Binding(Name = "ProcessDate")]
        public virtual DateTime? DateImport
        {
            get { return _dateImport; }
            set
            {
                _dateImport = value;
                RaisePropertyChanged(() => DateImport);
            }
        }

        [Binding(Name = "SentDate")]
        public virtual DateTime? DateSent
        {
            get { return _dateSent; }
            set
            {
                _dateSent = value;
                RaisePropertyChanged(() => DateSent);
            }
        }

        [Binding(Name = "ConfirmDate")]
        public virtual DateTime? DateConfirm
        {
            get { return _dateConfirm; }
            set
            {
                _dateConfirm = value;
                RaisePropertyChanged(() => DateConfirm);
            }
        }

        [Binding(Name = "LastAnswerDate")]
        public virtual DateTime? DateLastAnswer
        {
            get { return _datLastAnswer; }
            set
            {
                _datLastAnswer = value;
                RaisePropertyChanged(() => DateLastAnswer);
            }
        }


        [Binding(Name = "reportYear")]
        public virtual string Year
        {
            set
            {
                _year = value;
                RaisePropertyChanged(() => Year);
            }
            get { return _year; }
        }

        [Binding(Name = "period")]
        public virtual string Period
        {
            get { return _period; }
            set
            {
                _period = value;
                RaisePropertyChanged(() => Period);
            }
        }

        [Binding(Name = "ReceiverCode")]
        public virtual string ReсeiverCode
        {
            set
            {
                _reсeiverCode = value;
                RaisePropertyChanged(() => ReсeiverCode);
            }
            get { return _reсeiverCode; }
        }

        [Binding(Name = "progress")]
        public virtual string Progress
        {
            get { return _progress; }
            set
            {
                _progress = value;
                RaisePropertyChanged(() => Progress);
            }
        }

        [Binding(Name = "StateId")]
        public virtual DocCirculationStates StateId
        {
            get { return _stateId; }
            set
            {
                if (_stateId == value)
                    return;
                _stateId = value;
                RaisePropertyChanged(() => StateId);
            }
        }
        
        [Binding(Name = "orgName")]
        public virtual string OrgName
        {
            get
            {
                if (String.IsNullOrWhiteSpace(_orgName))
                    _orgName = OrganizationShortName;
                return _orgName;
            }
            set
            {
                _orgName = value;
                RaisePropertyChanged(() => OrgName);
            }
        }
        
        [Binding(Name = "OrganizationShortName")]
        public virtual string OrganizationShortName
        {
            get { return _organizationShortName; }
            set
            {
                _organizationShortName = value;
                RaisePropertyChanged(() => OrganizationShortName);
            }
        }

        [Binding(Name = "Owner")]
        public virtual string Owner
        {
            get { return _owner; }
            set
            {
                _owner = value;
                RaisePropertyChanged(() => Owner);
            }
        }

        [Binding(Name = "DocCircId")]
        public virtual string DocCircId
        {
            get { return _docCircId; }
            set
            {
                _docCircId = value;
                RaisePropertyChanged(() => DocCircId);
            }
        }

        [Binding(Name = "DocCircTypeId")]
        public virtual int DocCircType
        {
            get { return _docCircType; }
            set
            {
                _docCircType = value;
                RaisePropertyChanged(() => DocCircType);
            }
        }

        [Binding(Name = "idTaxPayer")]
        public int? TaxpayerId
        {
            get { return _taxpayerId; }
            set
            {
                _taxpayerId = value;
                RaisePropertyChanged(() => TaxpayerId);
            }
        }
        [Binding(Name = "idUser")]
        public int? IdUser
        {
            get { return _idUser; }
            set
            {
                _idUser = value;
                RaisePropertyChanged(() => IdUser);
            }
        }

        [Binding(Name = "layout")]
        public int Layout
        {
            get { return _layout; }
            set
            {
                _layout = value;
                RaisePropertyChanged(() => Layout);
            }
        }
    }
}
